{===================================================================================================

  Comming Library

      .

====================================================================================================

  :

  07.01.2005  [*] .
  11.12.2003  [+] ComponentColor:      .
  04.02.2003  [*] .
  29.11.2002  [*]    CommingDesign  CommingRuntime
  23.06.2002  [*]   DifferenceColor.
  16.01.2001  [*] " "   75%.
  14.01.2001  [+]     .
              [*]    : 50%   clWindow  clBtnFace.
              [*]  .
  12.01.2001  [+]  .
  09.09.1998  [!]  Comming Library.

====================================================================================================
  Copyright 19982005 TSK Developer Laboratory, Moscow.                     Konstantin Tsvetkov
                                                                              e-mail: dev@tsklab.ru
                                                                              http://www.tsklab.ru
  CVS: $Id: CommingColor.pas,v 1.1 2012/02/23 06:37:51 tsk Exp $
===================================================================================================}
unit CommingColor;

interface

  uses  Windows, Graphics, Classes, Controls;

  //  ,  .
  function    DifferenceColor( Color1, Color2: TColor; Percent: Integer = 50 ): TColor;

  //  ,  .
  function    DifferenceChannel( C1, C2: Byte; Percent: Integer = 50 ): Byte;

  //      .
  function ComponentColor( Component: TControl ): TColor;

  var clInactiveControl: TColor;
      clDimWindow: TColor;

implementation
//==================================================================================================
function DifferenceColor( Color1, Color2: TColor; Percent: Integer ): TColor;
  var c1, c2: Integer;
begin
  c1 := ColorToRGB( Color1 );
  c2 := ColorToRGB( Color2 );
  Result := TColor( RGB( DifferenceChannel( GetRValue( c1 ), GetRValue( c2 ), Percent ),
                         DifferenceChannel( GetGValue( c1 ), GetGValue( c2 ), Percent ),
                         DifferenceChannel( GetBValue( c1 ), GetBValue( c2 ), Percent )))
end;
//==================================================================================================
function DifferenceChannel( C1, C2: Byte; Percent: Integer ): Byte;
begin
  if C1 > C2
    then Result := C2 + Round( ( C1 - C2 ) * Percent / 100 )
    else Result := C1 + Round( ( C2 - C1 ) * Percent / 100 );
end;
//==================================================================================================
function ComponentColor( Component: TControl ): TColor;
begin
  if ( csDesigning in Component.ComponentState )
    then Result := clWindow
    else Result := clDimWindow;
end;
//==================================================================================================
procedure ColorInitialize;
begin
  clInactiveControl := DifferenceColor( clBtnFace, clWindow );
  clDimWindow       := DifferenceColor( clBtnFace, clWindow, 70 );
end;
//==================================================================================================
initialization
  ColorInitialize;
//==================================================================================================
end.
