{=======================================================================================================================

  Comming Library

       .

========================================================================================================================

  :

  09.02.2012 [!]    Delphi XE2.
  28.10.2004 [*] .
  14.11.2002 [-]  TAB.
  08.05.2001 [*] ShowStop:  b   .
  23.04.2001 [+]   Hex-  .
  16.10.2000 [*]     .
  23.12.1999 [+]  .  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 19972012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingDialog.pas,v 1.2 2012/10/25 11:00:51 tsk Exp $
=======================================================================================================================}
unit CommingDialog;

interface

  function  ShowSave( Text: String ): Integer;
  function  ShowWarning( Text: String ): Boolean; overload;
  function  ShowWarning( Template: String; Args: array of const ): Boolean; overload;
  function  ShowStop( Text: String ): Boolean; overload;
  function  ShowStop( Template: String; Args: array of const ): Boolean; overload;
  function  ShowInform( Text: String ): Boolean;
  procedure ShowHex( P: PChar );

implementation

uses  SysUtils, Windows, Forms, Messages, Dialogs, Controls, Buttons;

//======================================================================================================================
function ShowSave( Text: String ): Integer;
begin
  Result := Application.MessageBox( PChar(Text), ' ',
                                  mb_IconQUESTION + mb_YesNoCancel );
end;
//======================================================================================================================
function ShowWarning( Text: String ): Boolean; overload;
begin
  Result := ( Application.MessageBox( PChar(Text), '',
                                  mb_IconWarning + mb_OKCancel ) = IDOK );
end;
//======================================================================================================================
function ShowWarning( Template: String; Args: array of const ): Boolean; overload;
begin
  Result := ( Application.MessageBox( PChar(Format( Template, Args )), '',
                                  mb_IconWarning + mb_OKCancel ) = IDOK );
end;
//======================================================================================================================
function ShowStop( Text: String): Boolean;
begin
  Result := ( Application.MessageBox( PChar(Text), '', mb_IconStop ) = IDOK );
end;
//======================================================================================================================
function ShowStop( Template: String; Args: array of const ): Boolean;
begin
  Result := ( Application.MessageBox( PChar(Format( Template, Args )),
                                                   '', mb_IconStop ) = IDOK );
end;
//======================================================================================================================
function ShowInform( Text: String): Boolean;
begin
  Result := ( Application.MessageBox( PChar(Text), '', MB_ICONINFORMATION ) = IDOK );
end;
//======================================================================================================================
procedure ShowHex( P: PChar );
  var S: String;
      i: Integer;
begin
  s := '';
  for i := 0 to 45(*Length( P ) - 1 *) do begin
    if ( i > 0 ) and (( i mod 16 ) = 0 ) then s := s + #13;
    s := s + IntToHex( Ord( P[i]), 2 ) + '-';
  end;
  ShowMessage( s );
end;
//======================================================================================================================
end.
