{=======================================================================================================================

  Comming Library

     .

========================================================================================================================

  :

  04.06.2013 [+] GetProduct:    .
  26.01.2012 [*] Delphi XE2
  20.07.2010 [*] GetBuildTime:  , -  .
  19.05.2010 [*] SetProduct:     .
  17.05.2010 [+] SetProduct:  .
  07.08.2002 [*]       .
  18.07.2002 [*]    GetVersion ( -).
  08.11.2001 [-]  TAB.
  29.01.2001 [+]  GetVersion (" ...  ...").
  09.01.2001 [+]  GetBuildTime (   ).
  13.12.2000 [+]  .
  09.09.1998 [!]  Comming Library.

========================================================================================================================
  Copyright 20052012 TSK Developer Laboratory, Moscow.                                         Konstantin Tsvetkov
                                                                                                  e-mail: dev@tsklab.ru
                                                                                                  http://www.tsklab.ru
  CVS: $Id: CommingVersionInfo.pas,v 1.3 2013/06/28 14:58:18 tsk Exp $
=======================================================================================================================}
unit CommingVersionInfo;

interface

  uses Windows, Forms, SysUtils, System.Win.Registry;

  function  GetVersionInfo: String;

  function  GetVersion( Text: String = ' '; TwoLine: Boolean = False ): String;

  //    :
  function  GetBuildTime( FileName: String = '*'): TDateTime;

  //  .
  type TRegProduct = ( rpDate, rpVersion );
  procedure SetProduct;
  function GetProduct( par: TRegProduct ): Variant;

implementation
//======================================================================================================================
function  GetVersionInfo: String;
  var VerText: PChar;
      InfoSize, Wnd: Cardinal;
      VerBuf: Pointer;
      VerSize: DWORD;
begin
  Result := '0.0.0.0';
  InfoSize := GetFileVersionInfoSize( PChar( Application.ExeName ), Wnd );
  if InfoSize <> 0 then begin
    GetMem( VerBuf, InfoSize );
    try
      if GetFileVersionInfo( PWChar( Application.ExeName ), Wnd, InfoSize, VerBuf) then
        if VerQueryValue( VerBuf, '\StringFileInfo\040904E4\FileVersion', pointer(VerText), VerSize )
          then Result := StrPas( VerText );
    finally
      FreeMem(VerBuf);
    end;
  end;
end;
//======================================================================================================================
function GetBuildTime( FileName: String ): TDateTime;
type
  UShort = Word;
  TImageDosHeader = packed record
    e_magic: UShort;                //  
    e_cblp: UShort;                 //      
    e_cp: UShort;                   //   
    e_crlc: UShort;                 // Relocations
    e_cparhdr: UShort;              //    
    e_minalloc: UShort;             // Minimum extra paragraphsneeded
    e_maxalloc: UShort;             // Maximum extra paragraphsneeded
    e_ss: UShort;                   //  ()   SS
    e_sp: UShort;                   //   SP
    e_csum: UShort;                 //  
    e_ip: UShort;                   //    IP
    e_cs: UShort;                   //  ()   CS
    e_lfarlc: UShort;               //      
    e_ovno: UShort;                 //  
    e_res: array[0..3] of UShort;   // 
    e_oemid: UShort;                // OEM identifier (for e_oeminfo)
    e_oeminfo: UShort;              // OEM information; e_oemid specific
    e_res2: array[0..9] of UShort;  // 
    e_lfanew: LongInt;              //     .exe
  end;

  TImageResourceDirectory = packed record
    Characteristics: DWord;
    TimeDateStamp: DWord;
    MajorVersion: Word;
    MinorVersion: Word;
    NumberOfNamedEntries: Word;
    NumberOfIdEntries: Word;
    //  IMAGE_RESOURCE_DIRECTORY_ENTRY DirectoryEntries[];
  end;
  PImageResourceDirectory = ^TImageResourceDirectory;

var
  hExeFile: HFile;
  ImageDosHeader: TImageDosHeader;
  Signature: Cardinal;
  ImageFileHeader: TImageFileHeader;
  ImageOptionalHeader: TImageOptionalHeader;
  ImageSectionHeader: TImageSectionHeader;
  ImageResourceDirectory: TImageResourceDirectory;
  Temp: Cardinal;
  i: Integer;
begin
  if FileName = '*' then FileName := Application.ExeName;
  hExeFile := CreateFile( PChar( FileName ), GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING, 0, 0);
  try
    ReadFile(hExeFile, ImageDosHeader, SizeOf(ImageDosHeader), Temp, nil);
    SetFilePointer(hExeFile, ImageDosHeader.e_lfanew, nil, FILE_BEGIN);
    ReadFile(hExeFile, Signature, SizeOf(Signature), Temp, nil);
    ReadFile(hExeFile, ImageFileHeader, SizeOf(ImageFileHeader), Temp, nil);
    ReadFile(hExeFile, ImageOptionalHeader, SizeOf(ImageOptionalHeader), Temp, nil);
    for i := 0 to ImageFileHeader.NumberOfSections - 1 do
      begin
        ReadFile(hExeFile, ImageSectionHeader, SizeOf(ImageSectionHeader), Temp, nil);
        if StrComp(@ImageSectionHeader.Name, '.rsrc') = 0 then Break;
      end;
    SetFilePointer(hExeFile, ImageSectionHeader.PointerToRawData, nil, FILE_BEGIN);
    ReadFile(hExeFile, ImageResourceDirectory, SizeOf(ImageResourceDirectory), Temp, nil);
  finally
    FileClose(hExeFile);
  end;

  Result := FileDateToDateTime(ImageResourceDirectory.TimeDateStamp);
end;
//======================================================================================================================
function  GetVersion( Text: String; TwoLine: Boolean ): String;
begin
  Result := Text;
  if (GetVersionInfo <> '0.0.0.0') then Result := Result + GetVersionInfo;
  if TwoLine then Result := Result + #13;
  Result := Result + '  ' + FormatDateTime( 'dd.mm.yyyy', GetBuildTime );
end;
//======================================================================================================================
procedure SetProduct;
  var Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  with Reg do begin
    RootKey := HKEY_LOCAL_MACHINE;
    if OpenKey( 'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\' + Application.Title, True ) then begin
//      and ( ReadString( 'InstallDate' ) < FormatDateTime( 'yyyymmdd', Now())) then begin
        WriteString( 'Publisher', 'TSK Dev Lab');
        WriteString( 'DisplayName', Application.Title );
        WriteString( 'DisplayVersion', GetVersionInfo );
        WriteString( 'InstallDate', FormatDateTime( 'yyyymmdd', Now()));
      end;
    CloseKey;
    Free;
  end;
end;
//======================================================================================================================
function GetProduct( par: TRegProduct): Variant;
  var Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  with Reg do begin
    RootKey := HKEY_LOCAL_MACHINE;
    if OpenKey( 'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\' + Application.Title, True ) then
      case par of
        rpDate: Result := ReadString( 'InstallDate' );
        rpVersion: Result := ReadString( 'DisplayVersion' );
      end;
{       WriteString( 'Publisher', 'TSK Dev Lab');
        WriteString( 'DisplayName', Application.Title ); }
    CloseKey;
    Free;
  end;
end;
//======================================================================================================================
end.
